/**
 * clash-bot-webapp-service
 * Clash Bot Webapp Service to support League of Legends Clash tournament scheduling with Discord.
 *
 * The version of the OpenAPI document: 1.1.0
 * Contact: rixxroid@gmail.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent, HttpParameterCodec, HttpContext } from '@angular/common/http';
import { Observable } from 'rxjs';
import { CreateNewTeamRequest } from '../model/createNewTeamRequest';
import { Team } from '../model/team';
import { UpdateTeamRequest } from '../model/updateTeamRequest';
import { Configuration } from '../configuration';
export declare class TeamService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    encoder: HttpParameterCodec;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private addToHttpParams;
    private addToHttpParamsRecursive;
    /**
     * Create a new Team
     * @param createNewTeamRequest All necessary parameters to create a Clash Bot League of Legends Clash Team
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    createNewTeam(createNewTeamRequest?: CreateNewTeamRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Team>;
    createNewTeam(createNewTeamRequest?: CreateNewTeamRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Team>>;
    createNewTeam(createNewTeamRequest?: CreateNewTeamRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Team>>;
    /**
     * Returns a single Team or multiple Teams that match the filtering criteria.
     * @param serverId The identifier of the Server to filter the Teams by.
     * @param name The name of the Team to retrieve.
     * @param tournament The name of the Tournament to filter the Teams by.
     * @param day The day of the Tournament to filter the Teams by.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getTeam(serverId: string, name?: string, tournament?: string, day?: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Array<Team>>;
    getTeam(serverId: string, name?: string, tournament?: string, day?: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Array<Team>>>;
    getTeam(serverId: string, name?: string, tournament?: string, day?: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Array<Team>>>;
    /**
     * Removes a Player from a Team
     * @param name the name of the Team to retrieve.
     * @param serverId the name of the Server to filter the Teams by.
     * @param tournament the name of the Tournament to filter the Teams by.
     * @param tournamentDay the day of the Tournament to filter the Teams by.
     * @param playerId the player id to remove from the Team.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    removePlayerFromTeam(name: string, serverId: string, tournament: string, tournamentDay: string, playerId: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Team>;
    removePlayerFromTeam(name: string, serverId: string, tournament: string, tournamentDay: string, playerId: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Team>>;
    removePlayerFromTeam(name: string, serverId: string, tournament: string, tournamentDay: string, playerId: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Team>>;
    /**
     * Updates the Team that matches the details passed.
     * @param updateTeamRequest The Team details to use to update a specific Team
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    updateTeam(updateTeamRequest?: UpdateTeamRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Team>;
    updateTeam(updateTeamRequest?: UpdateTeamRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Team>>;
    updateTeam(updateTeamRequest?: UpdateTeamRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Team>>;
}
