/**
 * clash-bot-webapp-service
 * Clash Bot Webapp Service to support League of Legends Clash tournament scheduling with Discord.
 *
 * The version of the OpenAPI document: 1.1.0
 * Contact: rixxroid@gmail.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent, HttpParameterCodec, HttpContext } from '@angular/common/http';
import { Observable } from 'rxjs';
import { PlacePlayerOnTentativeRequest } from '../model/placePlayerOnTentativeRequest';
import { Tentative } from '../model/tentative';
import { Configuration } from '../configuration';
export declare class TentativeService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    encoder: HttpParameterCodec;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private addToHttpParams;
    private addToHttpParamsRecursive;
    /**
     * A list of people on the tentative queue for upcoming Tournaments.
     * @param serverId The Server identifier to filter the tentative queue by.
     * @param tournamentName The Tournament name to filter by.
     * @param tournamentDay The Tournament day to filter by.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getTentativeDetails(serverId: string, tournamentName?: string, tournamentDay?: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Array<Tentative>>;
    getTentativeDetails(serverId: string, tournamentName?: string, tournamentDay?: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Array<Tentative>>>;
    getTentativeDetails(serverId: string, tournamentName?: string, tournamentDay?: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Array<Tentative>>>;
    /**
     * Places a player on the tentative queue for an upcoming Tournament.
     * @param placePlayerOnTentativeRequest Parameters to place a Player into the tentative queue
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    placePlayerOnTentative(placePlayerOnTentativeRequest?: PlacePlayerOnTentativeRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Tentative>;
    placePlayerOnTentative(placePlayerOnTentativeRequest?: PlacePlayerOnTentativeRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Tentative>>;
    placePlayerOnTentative(placePlayerOnTentativeRequest?: PlacePlayerOnTentativeRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Tentative>>;
    /**
     * Remove a player from the tentative queue for an upcoming Tournament.
     * @param serverId The name of the Server identifier the queue falls under.
     * @param playerId The player id to remove from the tentative queue with.
     * @param tournament The Tournament that the tentative queue belongs to.
     * @param tournamentDay The Tournament day that the tentative queue belongs to.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    removePlayerFromTentative(serverId: string, playerId: string, tournament: string, tournamentDay: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Tentative>;
    removePlayerFromTentative(serverId: string, playerId: string, tournament: string, tournamentDay: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Tentative>>;
    removePlayerFromTentative(serverId: string, playerId: string, tournament: string, tournamentDay: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Tentative>>;
}
