/**
 * clash-bot-webapp-service
 * Clash Bot Webapp Service to support League of Legends Clash tournament scheduling with Discord.
 *
 * The version of the OpenAPI document: 1.1.0
 * Contact: rixxroid@gmail.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent, HttpParameterCodec, HttpContext } from '@angular/common/http';
import { Observable } from 'rxjs';
import { AddToListOfPreferredChampionsRequest } from '../model/addToListOfPreferredChampionsRequest';
import { CreateNewListOfPreferredChampionsRequest } from '../model/createNewListOfPreferredChampionsRequest';
import { CreateUserRequest } from '../model/createUserRequest';
import { Player } from '../model/player';
import { Subscription } from '../model/subscription';
import { UpdateUserRequest } from '../model/updateUserRequest';
import { Configuration } from '../configuration';
export declare class UserService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    encoder: HttpParameterCodec;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private addToHttpParams;
    private addToHttpParamsRecursive;
    /**
     * Adds the requested champion to the users preferred champions. Cannot be greater than a length of 5.
     * @param id The Clash bot Player\&#39;s id
     * @param addToListOfPreferredChampionsRequest A League of Legends Champion to updated or remove with.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    addToListOfPreferredChampions(id: string, addToListOfPreferredChampionsRequest?: AddToListOfPreferredChampionsRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Array<string>>;
    addToListOfPreferredChampions(id: string, addToListOfPreferredChampionsRequest?: AddToListOfPreferredChampionsRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Array<string>>>;
    addToListOfPreferredChampions(id: string, addToListOfPreferredChampionsRequest?: AddToListOfPreferredChampionsRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Array<string>>>;
    /**
     * Updates the users preferred champions with an entirely new list. Cannot be greater than a length of 5.
     * @param id The Clash bot Player\&#39;s id
     * @param createNewListOfPreferredChampionsRequest A list of champions.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    createNewListOfPreferredChampions(id: string, createNewListOfPreferredChampionsRequest?: CreateNewListOfPreferredChampionsRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Array<string>>;
    createNewListOfPreferredChampions(id: string, createNewListOfPreferredChampionsRequest?: CreateNewListOfPreferredChampionsRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Array<string>>>;
    createNewListOfPreferredChampions(id: string, createNewListOfPreferredChampionsRequest?: CreateNewListOfPreferredChampionsRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Array<string>>>;
    /**
     * Create a new Clash Bot Player.
     * @param createUserRequest All necessary parameters to create a new Player
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    createUser(createUserRequest?: CreateUserRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Player>;
    createUser(createUserRequest?: CreateUserRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Player>>;
    createUser(createUserRequest?: CreateUserRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Player>>;
    /**
     * Retrieve a Clash Bot Player Details
     * @param id The id of the user to retrieve.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getUser(id: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Player>;
    getUser(id: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Player>>;
    getUser(id: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Player>>;
    /**
     * Removes the requested champion to the users preferred champions.
     * @param id The Clash bot Player\&#39;s id
     * @param champion the champion name to remove from the user\&#39;s list of champions
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    removeFromListOfPreferredChampions(id: string, champion: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Array<string>>;
    removeFromListOfPreferredChampions(id: string, champion: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Array<string>>>;
    removeFromListOfPreferredChampions(id: string, champion: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Array<string>>>;
    /**
     * Returns a list of preferred champions that the User has.
     * @param id The Clash bot Player\&#39;s id
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    retrieveListOfUserPreferredChampions(id: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Array<string>>;
    retrieveListOfUserPreferredChampions(id: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Array<string>>>;
    retrieveListOfUserPreferredChampions(id: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Array<string>>>;
    /**
     * Returns if the user is subscribed to receive Monday morning Discord DMs.
     * @param id The Clash bot Player\&#39;s id
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    retrieveUserSubscriptions(id: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Array<Subscription>>;
    retrieveUserSubscriptions(id: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Array<Subscription>>>;
    retrieveUserSubscriptions(id: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Array<Subscription>>>;
    /**
     * Adds user to Monday morning subscription
     * @param id The Clash bot Player\&#39;s id
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    subscribeUser(id: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Array<Subscription>>;
    subscribeUser(id: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Array<Subscription>>>;
    subscribeUser(id: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Array<Subscription>>>;
    /**
     * Removes user from Monday morning subscription.
     * @param id The Clash bot Player\&#39;s id
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    unsubscribeUser(id: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Array<Subscription>>;
    unsubscribeUser(id: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Array<Subscription>>>;
    unsubscribeUser(id: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Array<Subscription>>>;
    /**
     * Update an existing Clash Bot Player.
     * @param updateUserRequest Parameters to update a new Player
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    updateUser(updateUserRequest?: UpdateUserRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<Player>;
    updateUser(updateUserRequest?: UpdateUserRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpResponse<Player>>;
    updateUser(updateUserRequest?: UpdateUserRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
        context?: HttpContext;
    }): Observable<HttpEvent<Player>>;
}
